package buffers;

import java.util.Random;

public class ProdCons
implements Runnable
{
	Buffer<String> buf;
	boolean sonoProd;
	static long start;
	static Random r;

	public ProdCons(boolean pc, Buffer<String> b)
	{
		sonoProd = pc;
		buf = b;
	}

	public void run()
	{
		int i = 0;
		String name = Thread.currentThread().getName();
		if(sonoProd)
		{
			try
			{
				Thread.sleep(1000);
			}
			catch(InterruptedException ie)
			{
			}
			while(true)
			{
				System.out.println("Al tempo " + (System.currentTimeMillis() - start)/1000 + " produco");
				buf.insert(name + (i++));
				System.out.println("Al tempo " + (System.currentTimeMillis() - start)/1000 + " ho prodotto");
				/*
				try
				{
					//Thread.sleep(1000 + r.nextInt(2000));
				}
				catch(InterruptedException ie)
				{
				}
				*/
			}
		}
		else
		{
			while(true)
			{
				System.out.println("Al tempo " + (System.currentTimeMillis() - start)/1000 + " consumo");
				System.out.println(buf.remove());
				System.out.println("Al tempo " + (System.currentTimeMillis() - start)/1000 + " ho consumato");
				try
				{
					Thread.sleep(1000 + r.nextInt(5000));
				}
				catch(InterruptedException ie)
				{
				}
			}
		}
	}

	public static void main(String[] argv)
	{
		Buffer<String> b = new Buffer<String>(1);
		int i = 0;
		while(i < argv.length)
		{
			if(argv[i].equalsIgnoreCase("prod"))
			{
				(new Thread(new ProdCons(true, b))).start();
			}
			else
			{
				(new Thread(new ProdCons(false, b))).start();
			}
			i++;
		}
	}

	static
	{
		start = System.currentTimeMillis();
		r = new Random(start);
	}
}
