package remotizzazione;

import java.io.IOException;
import net.ClientTCP3;

public class RemCalc2
implements Runnable
{
	ClientTCP3 tc = null;
	static java.util.concurrent.atomic.AtomicInteger ai = new java.util.concurrent.atomic.AtomicInteger(0);

	public RemCalc2() throws IOException
	{
		tc = new ClientTCP3();
		tc.openStreams();
	}

	public double sum(double arg1, double arg2) throws CommException
	{
		double retval = 0;

		Operazione op = new Operazione();
		op.operazione = 0;
		op.d1 = arg1;
		op.d2 = arg2;
		try
		{
			op = (Operazione)tc.submit(op);
		}
		catch(ClassNotFoundException | IOException ioe)
		{
			throw new CommException(ioe.toString());
		}
		retval = op.result;

		return retval;
	}

	public double sub(double arg1, double arg2) throws CommException
	{
		double retval = 0;

		Operazione op = new Operazione();
		op.operazione = 1;
		op.d1 = arg1;
		op.d2 = arg2;
		try
		{
			op = (Operazione)tc.submit(op);
		}
		catch(ClassNotFoundException | IOException ioe)
		{
			throw new CommException(ioe.toString());
		}
		retval = op.result;

		return retval;
	}

	public double mul(double arg1, double arg2) throws CommException
	{
		double retval = 0;

		Operazione op = new Operazione();
		op.operazione = 2;
		op.d1 = arg1;
		op.d2 = arg2;
		try
		{
			op = (Operazione)tc.submit(op);
		}
		catch(ClassNotFoundException | IOException ioe)
		{
			throw new CommException(ioe.toString());
		}
		retval = op.result;

		return retval;
	}

	public double div(double arg1, double arg2) throws CommException
	{
		double retval = 0;

		Operazione op = new Operazione();
		op.operazione = 3;
		op.d1 = arg1;
		op.d2 = arg2;
		try
		{
			op = (Operazione)tc.submit(op);
		}
		catch(ClassNotFoundException | IOException ioe)
		{
			throw new CommException(ioe.toString());
		}
		retval = op.result;

		return retval;
	}

	public void run()
	{
		try
		{
			switch(ai.getAndIncrement()%4)
			{
				case 0:
					System.out.println("Chiedo 4 / 2");
					System.out.println("Ho chiesto 4/2 -> " + div(4.0, 2.0));
					break;
				case 1:
					System.out.println("Chiedo 4 + 2");
					System.out.println("Ho chiesto 4+2 -> " + sum(4.0, 2.0));
					break;
				case 2:
					System.out.println("Chiedo 4 - 2");
					System.out.println("Ho chiesto 4-2 -> " + sub(4.0, 2.0));
					break;
				case 3:
					System.out.println("Chiedo 4 * 2");
					System.out.println("Ho chiesto 4*2 -> " + mul(4.0, 2.0));
					break;
			}
		}
		catch(CommException ce)
		{
			ce.printStackTrace();
		}
	}

	public static void main(String[] argv) throws IOException, CommException
	{
		int i = 0;
		RemCalc2 rc = new RemCalc2();
		for(i=0;i<3;i++)
		{
			(new Thread(rc)).start();
		}
	}

}
