package locks;

import java.util.*;

public class MyLock3
{
	MyLock1 mutex = new MyLock1();
	int contatore;
	List<Thread> lockers;

	public MyLock3(int init)
	{
		contatore = init;
		lockers = new LinkedList<Thread>();
	}

	public boolean tryLock()
	{
		while(!mutex.tryLock())
		{
			//se ho una deadline a 10 ms, mi prendo un po' di margine. Non e' un numero mistico, e' cosi' per esempio.
			Thread.sleep(7);
		}
		if(contatore < 1)// ci sono gia' dentro in troppi
		{
			mutex.unlock();
			return false;
		}
		contatore--;
		lockers.add(Thread.currentThread());
		mutex.unlock();
		return true;
	}

	public boolean unlock()
	{
		while(!mutex.tryLock())
		{
			;
		}
		if(!lockers.remove(Thread.currentThread()))
		{
			// non sono tra i presenti nella zona critica, non mi posso togliere!
			mutex.unlock();
			return false;
		}
		contatore++;
		mutex.unlock();
		return true;
	}

	public static void main(String[] argv)
	{
		MyLock3 ml3 = new MyLock3(5);

		while(!ml3.tryLock())
		{
			;
		}
	}
}
